'-------------------------------------------------------------------------------------------

' : ATMEGA8A    "AVR"    
'  : BASCOM-AVR 2.0.7.1
' : sasha_1973

'-------------------------------------------------------------------------------------------


'---------------------------   -----------------------------------------

 $regfile = "m8def.dat"
 $crystal = 1000000
 $framesize = 32
 $hwstack = 40
 $swstack = 16
 $baud = 4800

'----------------------------   USART  --------------------------------------

'  Config Com1 = 4800 , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
  Config Pind.0 = Input       '   RxD,  USART
  Config Pind.1 = Output       '   TxD,  USART

'-------------------      ----------------------

 Config Portb.0 = Output : Buzer Alias Portb.0

'-------------------     ----------------------

 Config Portb.4 = Output : Led_norma Alias Portb.4

'-------------------      ------------------------

 Config Portb.2 = Input :  Alias Pinb.2 : Set 

'----------------------------   LCD  -------------------------------------

 Config Lcdpin = Pin , Rs = Portd.2 , E = Portd.3 , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7
 Config Lcd = 20 * 4 : Cursor Off Noblink : Cls
'-------------------------------------------------------------------------------
'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 

'-------------------------- _--------------------------------

 Deflcdchar 1 , 12 , 18 , 18 , 12 , 32 , 32 , 32 , 32       ' 
 Deflcdchar 5 , 14 , 10 , 10 , 10 , 14 , 31 , 31 , 14       '
'  Deflcdchar 6 , 4 , 5 , 15 , 20 , 4 , 14 , 10 , 27           '
'  Deflcdchar 7 , 232 , 244 , 232 , 227 , 228 , 228 , 227 , 224       ' 
'  Deflcdchar 8 , 2 , 6 , 30 , 30 , 30 , 6 , 2 , 32            '
'  Deflcdchar 9 , 32 , 25 , 11 , 4 , 26 , 19 , 32 , 32        ' 
'  Deflcdchar 10 , 9 , 26 , 28 , 27 , 28 , 26 , 9 , 32         '  
'  Deflcdchar 1 , 31 , 27 , 19 , 27 , 27 , 17 , 31 , 31       ' 1
'  Deflcdchar 2 , 31 , 17 , 29 , 27 , 23 , 17 , 31 , 31       ' 2
'  Deflcdchar 3 , 31 , 17 , 29 , 27 , 29 , 17 , 31 , 31       ' 3
'  Deflcdchar 4 , 31 , 21 , 21 , 17 , 29 , 29 , 31 , 31       ' 4
'  Deflcdchar 5 , 31 , 17 , 23 , 17 , 29 , 17 , 31 , 31       ' 5
'  Deflcdchar 6 , 31 , 17 , 23 , 17 , 21 , 17 , 31 , 31       ' 6
'  Deflcdchar 7 , 31 , 17 , 29 , 27 , 23 , 23 , 31 , 31       ' 7
'  Deflcdchar 8 , 31 , 17 , 21 , 17 , 21 , 17 , 31 , 31       ' 8
'  Deflcdchar 9 , 31 , 17 , 21 , 17 , 29 , 17 , 31 , 31       ' 9
'  Deflcdchar 0 , 31 , 17 , 21 , 21 , 21 , 17 , 31 , 31       ' 0

'-----------------------   DS18B20  ------------------------------------

 Config 1wire = Portb.1 : Ds18b20 Alias Pinb.1

'-----------------------     --------------------------------

 Dim Id_ds18b20(8) As Byte       '     ID Ds18b20
 Dim 1_vklyuchenie As Byte
 Dim Adres_id_ds18b20 As Word       '     ID Ds18b20  EEPROM 
 Dim Opros_ds18b20(8) As Byte
 Dim Kolichestvo_ds18b20 As Word       'Word/Integer       
 Dim Number_saved_ds18b20 As Byte
 Dim Temperatura_lcd As String * 8
 Dim Flag_gotovnosti_temperatury As Bit
 Dim Buffer_lcd_temperatura As String * 5
 Dim __ As Byte
 Dim T As Single , T0 As Single , T1 As Single       '   
 Dim Byte0 As Byte , Byte1 As Byte , T_celye As Byte , T_desyatye As Byte       '   
 Dim Zaderzhka_50_ms As Byte , Zaderzhka_100_ms As Byte , Zaderzhka_1000_ms As Word       '     TIMER0
 Dim Znak_temperatura As String * 2 , T_celye_lcd As String * 4 , T_desyatye_lcd As String * 2       'Temperatura As String * 10       '   
 Dim Zaderzhka As Word , Zaderzhka_1_ms As Byte , Zaderzhka_5_ms As Byte , Zaderzhka_10_ms As Byte       '     TIMER0
'-------------------------------------------------------------------------------
 Dim 1_id_ds18b20(8) As Byte , 2_id_ds18b20(8) As Byte       '     ID Ds18b20
 Dim 3_id_ds18b20(8) As Byte , 4_id_ds18b20(8) As Byte       '     ID Ds18b20
 Dim 5_id_ds18b20(8) As Byte , 6_id_ds18b20(8) As Byte       '     ID Ds18b20
 Dim 7_id_ds18b20(8) As Byte , 8_id_ds18b20(8) As Byte       '     ID Ds18b20
'-------------------------------------------------------------------------------
 Dim A As Byte , B As Byte , C As Byte , D As Byte , E As Byte , X As Byte , Y As Byte       '        LCD

'-----------------------     -----------------------------

 Declare Sub Bip_bip()
 Declare Sub Displey_lcd()
 Declare Sub Temperature()
 Declare Sub Error_ds18b20()
 Declare Sub Opros_id_ds18b20()
 Declare Sub Poisk_id_ds18b20()
 Declare Sub Init_temperatura()
 Declare Sub Sensor_not_found()
 Declare Sub Pervoe_vklyuchenie()
 Declare Sub ___ds18b20()
 Declare Sub _ds18b20()
 Declare Sub Save_eeprom_id_ds18b20()
 Declare Sub Reading_eeprom_id_ds18b20()
 Declare Sub Zapros_izmereniya_ds18b20()
 Declare Sub Preobrazovanie_temperature()
 Declare Function Zapros_kolichestva_ds18b20() As Integer       '    Ds18b20  

'--------       Ds18b20  --------

'  Call Poisk_id_ds18b20
'  Call ___ds18b20
'  Rcall Zapros_izmereniya_ds18b20
'-------------------------------------------------------------------------------
  Readeeprom 1_vklyuchenie , 1 : If 1_vklyuchenie <> 50 Then Rcall Pervoe_vklyuchenie
'-------------
  Readeeprom Number_saved_ds18b20 , 5 : Kolichestvo_ds18b20 = Number_saved_ds18b20
'--------------------------------------
  rcall Reading_eeprom_id_ds18b20

  rcall Init_temperatura
'-------------------------------------------------------------------------------------------
'=================================================
'------------------------------     -----------------------------------------
   Do
'---------
    Toggle Led_norma

    rcall Zapros_izmereniya_ds18b20

    rcall Opros_id_ds18b20

'    If Flag_gotovnosti_temperatury = 1 Then Rcall Displey_lcd

'---------
   Loop
  End
'=================================================

'                                         

'=================================================
'-------------------------------------------------------------------------------
  Zapros_izmereniya_ds18b20:       '   
'-------------------------
    1wreset
    1wwrite &HCC       '    
    1wwrite &H44       '  
'  Bitwait Ds18b20 , Set                                     '     
   Waitms 750       '  
'--------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Opros_id_ds18b20       '  Ds18b20
'-------------------------------
    __ = 1
    X = 1 : Y = 1 : 1wreset : 1wverify 1_id_ds18b20(1)       '1 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 2
    X = 2 : Y = 1 : 1wreset : 1wverify 2_id_ds18b20(1)       '2 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 3
    X = 3 : Y = 1 : 1wreset : 1wverify 3_id_ds18b20(1)       '3 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 4
    X = 4 : Y = 1 : 1wreset : 1wverify 4_id_ds18b20(1)       '4 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 5
    X = 1 : Y = 12 : 1wreset : 1wverify 5_id_ds18b20(1)       '5 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 6
    X = 2 : Y = 12 : 1wreset : 1wverify 6_id_ds18b20(1)       '6 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 7
    X = 3 : Y = 12 : 1wreset : 1wverify 7_id_ds18b20(1)       '7 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If
'-------------------------------
    __ = 8
    X = 4 : Y = 12 : 1wreset : 1wverify 8_id_ds18b20(1)       '8 ds18b20   (=1)  
    If Err = 0 Then
      Rcall Preobrazovanie_temperature
    Else
      Error_ds18b20
    End If

    Print ""
    Print ""
'-------------------------------
  End Sub '    Ds18b20
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Preobrazovanie_temperature:       '  
'--------------------------------
    1wwrite &HBE       '   

    Byte0 = 1wread()       '  
    Byte1 = 1wread()       '  

  If Byte1 > 248 Then       '   
    Byte0 = &H101 - Byte0
    Byte1 = &HFF - Byte1

    Znak_temperatura = "-"       ' "-"
  Else
    Znak_temperatura = " "       '  "+",  
  End If

    T0 = Byte0 * 0.0625       '      4  (2*2*2*2=16)

    T1 = Byte1 * 16       '      4  (2*2*2*2=16)

    T0 = T0 + T1       '      

    T_celye = T0       '  (  )

    T_celye_lcd = Str(t_celye)       '  ,     LCD

    T_celye_lcd = Format(t_celye_lcd , " 0")       '   LCD

    T0 = T0 - T_celye       '   

    T0 = T0 * 10       '  

    T_desyatye = T0       '  (  )

    T_desyatye_lcd = Str(t_desyatye)

    If T_celye > 99 Then Znak_temperatura = ""       '  99 ,     1 (  )
'--------------------------------


    Temperatura_lcd = Chr(5) + " " + Znak_temperatura + T_celye_lcd + "." + T_desyatye_lcd + Chr(1) + "C"
   rcall Displey_lcd
  End Sub
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Displey_lcd:
'-----------------
    Locate X , Y : Lcd Temperatura_lcd

    Print " " ; __ ; " " ; Znak_temperatura ; T_celye_lcd ; "." ; T_desyatye_lcd ; "C"
'---------
 End Sub
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Error_ds18b20:
'-------------------------------
'    For A = 1 To
     Locate X , Y : Lcd Chr(5) ; "        "
      Waitms 100
       Locate X , Y : Lcd Chr(5) ; "  Error "
       Print "  " ; __
'      Waitms 250
'     Next
'-------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Sensor_not_found:
'-------------------------------
     For A = 1 To 3
       Locate X , Y : Lcd "                    "
         Waitms 500
           Locate X , Y : Lcd " " ; D ; " Sensor not found "
           Print "  "
         Waitms 500
     Next A
'-------------------------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  Init_temperatura:
'------------------
     E = 0 : X = 1 : Y = 1
     1wreset : 1wverify 1_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 1 Sensor CRC Ok "
     Print  "1 Sensor CRC Ok"
   Else
     D = 1
     Sensor_not_found
   End If
'---------------------------------------------------
     X = 2 : Y = 1
     1wreset : 1wverify 2_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 2 Sensor CRC Ok "
     Print "2 Sensor CRC Ok"
   Else
     D = 2
     Sensor_not_found
   End If
'---------------------------------------------------
     X = 3 : Y = 1
     1wreset : 1wverify 3_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 3 Sensor CRC Ok "
     Print "3 Sensor CRC Ok"
   Else
     D = 3
     Sensor_not_found
   End If
'---------------------------------------------------
     X = 4 : Y = 1
     1wreset : 1wverify 4_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 4 Sensor CRC Ok "
     Print "4 Sensor CRC Ok"
   Else
     D = 4
     Sensor_not_found
   End If
'---------------------------------------------------
   rcall Bip_bip : rcall Bip_bip : Wait 1 : Cls
'---------------------------------------------------
     X = 1 : Y = 1
     1wreset : 1wverify 5_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 5 Sensor CRC Ok "
     Print "5 Sensor CRC Ok"
   Else
     D = 5
     Sensor_not_found
   End If
'---------------------------------------------------
     X = 2 : Y = 1
     1wreset : 1wverify 6_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 6 Sensor CRC Ok "
     Print "6 Sensor CRC Ok"
   Else
     D = 6
     Sensor_not_found
   End If
'---------------------------------------------------
    X = 3 : Y = 1
     1wreset : 1wverify 7_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 7 Sensor CRC Ok "
     Print "7 Sensor CRC Ok"
   Else
     D = 7
     Sensor_not_found
   End If
'---------------------------------------------------
     X = 4 : Y = 1
     1wreset : 1wverify 8_id_ds18b20(1)       '    '     
   If Err = 0 Then
     E = E + 1
     Locate X , Y : Lcd " 8 Sensor CRC Ok "
     Print "8 Sensor CRC Ok"
   Else
     D = 8
     Sensor_not_found
   End If
'---------------------------------------------------

   rcall Bip_bip : rcall Bip_bip : Wait 1 : cls

'---------------------------------------------------
   1wreset       '  
   1wwrite &HCC       '      
   1wwrite &H44       '   
'---------------------------------------------------
 If E = Kolichestvo_ds18b20 Then
   Upperline : Lcd "   All registered   "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
   Lowerline : Lcd "  sensors  Ds18b20  "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
   Thirdline : Lcd "       found        "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
   Print ""
   Print "   "
   Print ""
 Else
   Upperline : Lcd "         " ; E ; "         "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
   Lowerline : Lcd "  sensors  Ds18b20  "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
   Thirdline : Lcd "       found        "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
 End If
'---------------------------------------------------
   rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip
   Waitms 500
   rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip
   Waitms 500
   rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip : rcall Bip_bip
'---------------
  Wait 3 : Cls
'---------------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'*********     ID DS18B20  EEPROM  ********
'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Save_eeprom_id_ds18b20       '    ID DS18B20  EEPROM 
'----------------------------
'=========   ==========
  Id_ds18b20(1) = 1wsearchfirst()       '       8-    
'==================================
    Adres_id_ds18b20 = 10       '  10  (   (  - 10 ,   - 20   .. ))
      For B = 1 To 8       '  8  ,  ID DS18B20
        Writeeeprom Id_ds18b20(b) , Adres_id_ds18b20       '      
          Waitms 5       ' ~ 5ms
        Incr Adres_id_ds18b20       '   1
      Next B       '     ID   

    rcall _ds18b20

'-------    --------
  For A = 2 To Kolichestvo_ds18b20
'===================================
    Id_ds18b20(1) = 1wsearchnext()       '       8-    
'===================================
      Adres_id_ds18b20 = Adres_id_ds18b20 + 2       '   2, -  ,  ( )
        For B = 1 To 8       '  8  ,  ID DS18B20
          Writeeeprom Id_ds18b20(b) , Adres_id_ds18b20       '      
            Waitms 5       ' ~ 5ms
          Incr Adres_id_ds18b20       '   1
        Next B       '     ID  

    rcall _ds18b20

      Next A       '    
     A = A - 1
    Number_saved_ds18b20 = A
   Writeeeprom Number_saved_ds18b20 , 5

  rcall Bip_bip
'----------
  End Sub '      ID DS18B20  EEPROM 
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
 Function Zapros_kolichestva_ds18b20() As Integer
'---------------------------------------------------
' Local A As Byte
'-----------------
    For A = 1 To 5       '  ,  LCD 5 
      Cls ' LCD
        Waitms 250
'=============================================
          Kolichestvo_ds18b20 = 1wirecount()       '   Ds18b20  
'=============================================
        Locate 1 , 1 : Lcd "    It is found     "       '  LCD ""
        Locate 2 , 1 : Lcd " " ; Kolichestvo_ds18b20 ; " sensors DS18B20"       '      
      Waitms 500       ' ~ 750ms
    Next  '

      Print " " ; Kolichestvo_ds18b20 ; " "       '     Ds18b20  
      Print ""

      Waitms 500       ' ~ 1s
    Cls

  rcall Bip_bip
'---------------
  End Function
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
  Sub Pervoe_vklyuchenie:
'-------------------------------
    rcall Zapros_kolichestva_ds18b20

    rcall Save_eeprom_id_ds18b20

    Print A ; " ID  Ds18b20   EEPROM MK"
    Print ""

    For B = 1 To 3
      Cls
        Waitms 500
          Locate 1 , 1 : Lcd "         " ; A
          Locate 2 , 1 : Lcd " ID Sensors Ds18b20 "
          Locate 3 , 1 : Lcd "       saved        "
        Waitms 500
    Next B

  Waitms 1000

    rcall Reading_eeprom_id_ds18b20 : rcall Bip_bip

    Print A ; " ID  Ds18b20   EEPROM MK"
    Print ""

    For B = 1 To 3
      Cls
        Waitms 500
          Locate 1 , 1 : Lcd "         " ; A
          Locate 2 , 1 : Lcd " ID Sensors Ds18b20 "
          Locate 3 , 1 : Lcd "        Read        "
        Waitms 500
    Next B



  Waitms 1000
    1_vklyuchenie = 50
      Writeeeprom 1_vklyuchenie , 1
        Waitms 10

   rcall Bip_bip : Cls
'----------
  End Sub
'*******************************************************************************

'*******************************************************************************
'*********   ID DS18B20  EEPROM  ****************
'*******************************************************************************
'-------------------------------------------------------------------------------
  Sub Reading_eeprom_id_ds18b20
'-------------------------------
'  Local A As Byte , B As Byte
'-------------------------------
  Adres_id_ds18b20 = 10
'-----------------------
    For A = 1 To Kolichestvo_ds18b20       'Kolichestvo_ds18b20
      For B = 1 To 8
        Readeeprom Id_ds18b20(b) , Adres_id_ds18b20
          Select Case Adres_id_ds18b20
            Case 10 To 19 : 1_id_ds18b20(b) = Id_ds18b20(b)
            Case 20 To 29 : 2_id_ds18b20(b) = Id_ds18b20(b)
            Case 30 To 39 : 3_id_ds18b20(b) = Id_ds18b20(b)
            Case 40 To 49 : 4_id_ds18b20(b) = Id_ds18b20(b)
            Case 50 To 59 : 5_id_ds18b20(b) = Id_ds18b20(b)
            Case 60 To 69 : 6_id_ds18b20(b) = Id_ds18b20(b)
            Case 70 To 79 : 7_id_ds18b20(b) = Id_ds18b20(b)
            Case 80 To 89 : 8_id_ds18b20(b) = Id_ds18b20(b)
            Case Else
          End Select
        Adres_id_ds18b20 = Adres_id_ds18b20 + 1
      Next B
     Adres_id_ds18b20 = Adres_id_ds18b20 + 2
    Next A
   A = A - 1
'----------
  End Sub '      ID DS18B20  EEPROM 
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------    TIMER0 -------------------------
'-------------------------------------------------------------------------------
  Pauza:
'-------
    Zaderzhka = Zaderzhka + 1       ': If Zaderzhka = 4 Then Zaderzhka = 0
'    Zaderzhka_1_ms = Zaderzhka + 1 : If Zaderzhka = 4 Then Zaderzhka = 0
'    Zaderzhka_5_ms = Zaderzhka_1_ms + 1 : If Zaderzhka_5_ms = 20 Then Zaderzhka_5_ms = 0
'    Zaderzhka_10_ms = Zaderzhka_5_ms + 1 : If Zaderzhka_10_ms = 40 Then Zaderzhka_5_ms = 0
'    Zaderzhka_50_ms = Zaderzhka_10_ms + 1 : If Zaderzhka_50_ms = 200 Then Zaderzhka_50_ms = 0
'    Zaderzhka_100_ms = Zaderzhka_50_ms + 1 : If Zaderzhka_100_ms = 4 Then Zaderzhka_100_ms = 0 : Rcall Opros_id_ds18b20
'    Zaderzhka_1000_ms = Zaderzhka_100_ms + 1 : If Zaderzhka_1000_ms = 4 Then Zaderzhka_1000_ms = 0 : Rcall Zapros_izmereniya_ds18b20


      Select Case Zaderzhka       'Zaderzhka = 1=250; 250*4=1mc
       Case Is = 4 : Rcall Zapros_izmereniya_ds18b20
       'Case Is = 40 : Rcall Displey_lcd                     '   LCD?   10 ms
       Case Is = 3000 : Rcall Opros_id_ds18b20       '       
       Case Is = 3001 :
            Toggle Led_norma
                   Zaderzhka = 0
       Case Else
      End Select
'-------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
   Bip_bip:
'----------
     Set Buzer : Waitms 100 : Reset Buzer
'----------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************

'*******************************************************************************
'-------------------------------------------------------------------------------
  _ds18b20:
'-----------------------
    Upperline : Lcd "      Nazhmite      "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 
    Lowerline : Lcd "       knopku       "       'Upperline  1 , Lowerline  2 , Thirdline  3 , Fourthline 4 

    Print " "
    Print ""

    Bitwait  , Reset

    Waitms 5
'----------
  Return
'-------------------------------------------------------------------------------
'*******************************************************************************


'###############################################################################
'###############################################################################
'###############################################################################

'*******************************************************************************
  Sub Poisk_id_ds18b20:
'-------------------------------
   1_id_ds18b20(1) = 1wsearchfirst()
'   For A = 1 To 8
'     Id_ds18b20(a) = 1_id_ds18b20(a)
'   Next A
'     rcall ___ds18b20
'--------------------------------------
   2_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 2_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   3_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 3_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   4_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 4_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   5_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 5_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   6_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 6_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   7_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 7_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'--------------------------------------
   8_id_ds18b20(1) = 1wsearchnext()
'   For A = 1 To 8
'     Id_ds18b20(a) = 8_id_ds18b20(a)
'   Next A
'   rcall ___ds18b20
'----------
  End Sub
'*******************************************************************************






'       - all registered sensors found

'     - Does Not Match

'     - Not Found

'     - Test Passed

'      - test Fails

'    - Initialization




'**************************************************************************************************
'*                                ds18b20                                  *
'*   (7F - 12 , 5F - 11  , 3F - 10  , 1F - 9 )    Ds18b20 *
'*                           Alarm search   Ds18b20                             *
'**************************************************************************************************
'===============================================================================
'======================     Ds18b20 ==========================
'===============================================================================
'    1wreset                                                 '  
'    1wverify 1_id_ds18b20(1)                                '     
'   ==============
'    1wwrite &H4E                                            '      
'   ==============
'    1wwrite &H78                                            '   (    "120C")
'    1wwrite &HCE                                            '   (   "-50C")
'    1wwrite &H7F                                            '    (7F - 12 , 5F - 11  , 3F - 10  , 1F - 9 )
'   ==============
'    1wverify 1_id_ds18b20(1)                                '     
'    1wwrite &H48                                            '        ,   
'    1wreset                                                 '  
'   ==============
'     Waitms 20
'===============================================================================
'**************************************************************************************************
'**************************************************************************************************


'**************************************************************************************************
'*******************************************************************************
'  Sub ___ds18b20:
'-------------------------------
'===============================================================================
'======================     Ds18b20 ==========================
'===============================================================================
'    1wreset                                                 '  
'    1wverify Id_ds18b20(1)                                  '     
  '==============
'    1wwrite &H4E                                            '      
  '==============
'    1wwrite &H78                                            '   (    "120C")
'    1wwrite &HCE                                            '   (   "-50C")
'    1wwrite &H7F                                            '    (7F - 12 , 5F - 11  , 3F - 10  , 1F - 9 )
  '==============
'    1wverify Id_ds18b20(1)                                  '     
'    1wwrite &H48                                            '        ,   
'    1wreset                                                 '  
  '==============
'     Waitms 20
'===============================================================================
'----------
'  End Sub
'*******************************************************************************
'**************************************************************************************************
'   1wreset                                                  '  
'   1wwrite &HCC                                             '     
'   1wwrite &H4E                                             '     
'   1wwrite &H78                                             '   (  )
'   1wwrite &HCE                                             '   (  )
'   1wwrite &H7F                                             '    (7F - 12 , 5F - 11  , 3F - 10  , 1F - 9 )
'   1wwrite &H48                                             '    Ds18b20